/*
3 jump types
 8 possible control actions that can trigger
 = 24
 
 NOT TOO BIG
 */
enum MoveType{r_none,r_jump, r_fail};

struct MoveInfo
{
	MoveType movetype;
	
	union {
		struct {
			int control;
			bool controldir;
			bool param;
			bool paramdir;
		} jump;
		
		struct {
			int control;
			bool controldir;
			bool xfail;
			bool yfail;
		} fail;
	};
};


int MoveInfoToInt(const MoveInfo& s)
{
	switch (s.movetype)
	{
		case r_none://assume mutually exclusive x and y)
			return -1;
			break;
		case r_jump:
			return 1+16*s.jump.param + 8*s.jump.paramdir + 2*s.jump.control + s.jump.controldir;
			break;
		case r_fail:
			if (s.fail.xfail&&s.fail.yfail)
			{
				return 1+32+16+2*s.fail.control+s.fail.controldir;
			}
			else if (s.fail.xfail)
			{
				return 1+32+2*s.fail.control+s.fail.controldir;
			}
			else//yfail
			{
				return 1+32+8+2*s.fail.control+s.fail.controldir;	
			}
			break;
		default:
			return -1;
			break;
	}

	
	return 0;
}

string curstring;
/*
string startstrings[7] =
{
"",
"",
"",
"i find myself, alone. ",
"i sit on the chair, and watch my sweet daughter playing with her father. ",
"the two young boys, the play together out in the park",
"she stoops to cross herself as she passes the altar"

};
*/


char* description[7][4]={
{"step back/forward","item 02","item 03","item 04"},
{"step towards/away","eat less/more","item 13","item 14"},
{"read less/more","relax/concentrate","look away/at","item 24"},
{"less/more action","less/more artistry","less/more linearity","less/more emotion"},
{"pray less/more","sin less/more","read less/more","item 44"},
{"earlier/later","younger/older","happier/sadder","item 54"},
{"listen","look","smell","touch"},
};

const int STRINGCOUNT=32+24+1;
bool stringseen[STRINGCOUNT];

const string jumpstrings[7][STRINGCOUNT] =
{
//CAT0: Fold
{
//DEFAULT
"my dear, my love, please come down.  please don't jump! ",	
//JUMP
////JUMPX
//////JUMPX+
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//////JUMPX-
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
////JUMPY
//////JUMPY+
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//////JUMPY-
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//FAIL
////FAILX
"",	// a-
"how could he be so wicked, so utterly selfish? ",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
////FAILY
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
////FAILBOTH
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
},

//CAT1: Cusp
{
//DEFAULT
"i'm standing here, in front of the mirror.  i feel so ugly, so fat. ",	
//JUMP
////JUMPX
//////JUMPX+
"",	// a-
"",	// a+
"",	// b-
"i can't be happy with all this fat hanging off me, eating like other people, like pigs. ",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//////JUMPX-
"",	// a-
"",	// a+
"this is better, so much better; I am so beautiful. ",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
////JUMPY
//////JUMPY+
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//////JUMPY-
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//FAIL
////FAILX
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
////FAILY
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
////FAILBOTH
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
},

//CAT2: Swallowtail
{
//DEFAULT
"the park is so calm today.  i sit reading; there is a handsome fellow nearby. ",	
//JUMP
////JUMPX
//////JUMPX+
"this isn't a book; it's a pretence.  god he's beautiful! ",	// a-
"",	// a+
"",	// b-
"i wonder what it must be like to bite his neck, to run my hands around him. ",	// b+
"",	// c-
"oh gosh, did he just notice me staring at him?  and, did he smile back? ",	// c+
"",	// d-
"",	// d+
//////JUMPX-
"",	// a-
"this is so artfully written, so utterly beautiful a book. ",	// a+
"this book is overdue back to the library, i think. ",	// b-
"",	// b+
"i feel so ashamed to be sitting near someone so beautiful. ",	// c-
"",	// c+
"",	// d-
"",	// d+
////JUMPY
//////JUMPY+
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//////JUMPY-
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//FAIL
////FAILX
"screw the book; i'm going to go over and talk to him. ",	// a-
"i think i'll have to wait here until i've finished the book. ",	// a+
"oh mild, clement day, how sweet is your breeze. ",	// b-
"there are two men and a book.  i am one, and he is the other. ",	// b+
"i have to leave; i can't bear his presence",	// c-
"there is only the bliss of his eyes. ",	// c+
"",	// d-
"",	// d+
////FAILY
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
////FAILBOTH
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
},

//CAT3: Butterfly
{
//DEFAULT
"i sit, on my bed, thinking of to make a game. i feel ... uncertain. ",	
//JUMP
////JUMPX
//////JUMPX+
"what beautiful serenity i think i can evoke, if i restrain myself. ",	// a-
"yes! some motivity, some speed is just what the game needs. ",	// a+
"what happy baseness this game should exhibit! ",	// b-
"i see what i can do with this, now; a profound experience, and thoughtful. ",	// b+
"this game, it needs the freedom of exploration; many beautiful vistas. ",	// c-
"not a game, some will say, but a directed course of action. ",	// c+
"this will constitute a masterpiece of emotional asceticism. ",	// d-
"i ... even cry ... just thinking about it now ... it's so deeply affecting. ",	// d+
//////JUMPX-
"what have i been thinking?  this is so dull, so god-awful boring. ",	// a-
"all this pace, and yet ... i feel it's loosing something. ",	// a+
"no no no no no; my ... intentions are getting lost ... it needs more. ",	// b-
"oh gosh; people are really going to think i'm stuck up my own ass. ",	// b+
"nobody is going to have any idea what to do at all. ",	// c-
"this game is going to be ... grotesquely linear",	// c+
"this idea leaves me so unmoved, so ... dissatisfied ... ",	// d-
"oh man, no; not even i can stick that level of affectation. ",	// d+
////JUMPY
//////JUMPY+
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//////JUMPY-
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//FAIL
////FAILX
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
////FAILY
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
////FAILBOTH
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
},

//CAT4: Pyramid
{
//DEFAULT
"sister mary sits at her desk, reading marx.  all is quiet. ",	
//JUMP
////JUMPX
//////JUMPX+
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//////JUMPX-
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
////JUMPY
//////JUMPY+
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//////JUMPY-
"",	// a-
"",	// a+
"",	// b-
"",	// b+
"",	// c-
"",	// c+
"",	// d-
"",	// d+
//FAIL
////FAILX
"god helps those who help themselves. ",	// a-
"god, please help me; i am beset with worries and troubles. ",	// a+
"i must strive to be virtuous always. ",	// b-
"how twisted, horrible must i be to entertain sinful intent? ",	// b+
"i ... cannot understand this man; he is speaking nonsense. ",	// c-
"i am wed to society; there is nothing else. ",	// c+
"",	// d-
"",	// d+
////FAILY
"god helps those who help themselves. ",	// a-
"god, please help me; i am beset with worries and troubles. ",	// a+
"i must strive to be virtuous always. ",	// b-
"how twisted, horrible must i be to entertain sinful intent? ",	// b+
"i ... cannot understand this man; he is speaking nonsense. ",	// c-
"i am wed to society; there is nothing else. ",	// c+
"",	// d-
"",	// d+
////FAILBOTH
"god helps those who help themselves. ",	// a-
"god, please help me; i am beset with worries and troubles. ",	// a+
"i must strive to be virtuous always. ",	// b-
"how twisted, horrible must i be to entertain sinful intent? ",	// b+
"i ... cannot understand this man; he is speaking nonsense. ",	// c-
"i am wed to society; there is nothing else. ",	// c+
"",	// d-
"",	// d+
},

//CAT5: Purse
{
//DEFAULT
"a boy and a girl, they play together out in the park. ",	
//JUMP
////JUMPX
//////JUMPX+
"the boy was up early this morning; and grows tired now. ",	// a-
"i can see the boy yawn in anticipation of the evening. ",	// a+
"the boy was so cranky when he was a baby; he cried all day and night. ",	// b-
"i wonder what the future has in store; he wishes to be a fireman. ",	// b+
"the boy smiles a smile of happy resignation; play will soon be over. ",	// c-
"the boy suddenly snaps at the girl; he grows impatient for her attention. ",	// c+
"",	// d-
"",	// d+
//////JUMPX-
"the boy was so upset this morning that he did not eat. ",	// a-
"i hope the boy will be able to sleep soundly tonight. ",	// a+
"the boy is so much more trouble now than when he was younger. ",	// b-
"i ... do not look forward to the boy's adolescence. ",	// b+
"the boy has had so much happiness at my expense. ",	// c-
"his father only ever caused that boy sadness. ",	// c+
"",	// d-
"",	// d+
////JUMPY
//////JUMPY+
"she spent an our this morning trying on my shoes. ",	// a-
"i hope she isn't too fussy at dinner tonight. ",	// a+
"she was such a quiet baby; she barely spoke a word. ",	// b-
"i hope the girl manages to make a good life for herself. ",	// b+
"the girl smiles so rarely, but is always polite. ",	// c-
"when she is with the boy, she is always so happy. ",	// c+
"",	// d-
"",	// d+
//////JUMPY-
"she complained about the boy all morning, but she seems happy now. ",	// a-
"she gets so sad at bedtime; she misses her father. ",	// a+
"we were so unhappy when she was younger; it's better now, though. ",	// b-
"i hope she won't resent us, when she grows up, for our decisions. ",	// b+
"she expresses such delight at the boy's frustration. ",	// c-
"she barely moved all yesterday; there was no one to play with. ",	// c+
"",	// d-
"",	// d+
//FAIL
////FAILX
"he is unbearable in the mornings. ",	// a-
"i cannot stand his contrariness at bedtimes; i loose hope sometimes.  ",	// a+
"he was a wretched baby.  i think i have failed him. ",	// b-
"he will grow up to be a nobody, a failure.  i've given it my best. ",	// b+
"he's a spoiled brat; i resent his every greedy expression of delight. ",	// c-
"i don't even bother to try with him any more; he's a lost cause. ",	// c+
"",	// d-
"",	// d+
////FAILY
"i should have paid her more attention when she was younger. ",	// a-
"she's such a promiscuous girl; i hope it wears off ... ",	// a+
"i wonder what life would have been like had i had an abortion, then. ",	// b-
"i did the right thing, by taking her away from her father. ",	// b+
"that little girl derives pleasure from the cruellest of acts. ",	// c-
"she only knows how to mourn her own losses.  she is so selfish. ",	// c+
"",	// d-
"",	// d+
////FAILBOTH
"they both caused me so much trouble this morning. ",	// a-
"i don't look forward to bringing them to their father later. ",	// a+
"i was drunk all the time when they were younger. ",	// b-
"i won't be around in their lives for much longer. ",	// b+
"i beat them once, for laughing, when i was hung-over. ",	// c-
"i remember waking up once, on the kitchen floor; and they were crying. ",	// c+
"",	// d-
"",	// d+
},

//CAT6: Parabola
{
//DEFAULT
"i'm sitting on the couch, next to her. ",	
//JUMP
////JUMPX
//////JUMPX+
"i find it hard to concentrate on her words, so beautiful is her voice. ",	// a-
"i can hear my heart thumping. ",	// a+
"i look away from her; i can feel her gaze upon me. ",	// b-
"i find myself looking at her face; it's so pretty. ",	// b+
"i hold my breath for some seconds, to savour the silence. ",	// c-
"i inhale deeply; she smells so sweet. ",	// c+
"i draw away from her slightly; she responds by coming closer still. ",	// d-
"i can feel our arms touching.  the sensation thrills me. ",	// d+
//////JUMPX-
"i'm beginning to find that she speaks too much.",	// a-
"i find myself disagreeing with so many of her opinions. ",	// a+
"i wish I had the courage to look her in the eyes. ",	// b-
"she's not very good-looking, not really. ",	// b+
"i find her perfume unendearing. ",	// c-
"her perfume sickens me a little; it's very strong. ",	// c+
"i draw away from her slightly; I'm not comfortable around her. ",	// d-
"",	// d+
////JUMPY
//////JUMPY+
"she's taking charge of the conversation, and with what charm. ",	// a-
"she's so thoughtful in her conversation. ",	// a+
"she looks away from me, bashfully.",	// b-
"she looks me straight in the eyes, for the fist time. ",	// b+
"she asks me to be more direct with my affections. ",	// c-
"she asks me to come closer, that she might smell me better. ",	// c+
"she takes her hand off my knee, and grins teasingly. ",	// d-
"she puts her arms around me. ",	// d+
//////JUMPY-
"i get the feeling she's not listening to me. ",	// a-
"i feel like i'm talking to myself; she barely speaks. ",	// a+
"she doesn't so much as glance at me. ",	// b-
"she looks at me, and i writhe uncomfortably. ",	// b+
"she says she doesn't like my aftershave. ",	// c-
"i hear her sniff pointedly in my direction; i'm mortified. ",	// c+
"she moves to sit at the far end of the couch. ",	// d-
"she tells me she doesn't want to move this fast. ",	// d+
//FAIL
////FAILX
"i tell her i'm tired of being ignored, that it's over. ",	// a-
"i tell her that she's too quiet for me. ",	// a+
"i tell her that i'm not physically attracted to her. ",	// b-
"i tell her that i think she's out of my league. ",	// b+
"i make an excuse and leave; her perfume is unbearable. ",	// c-
"i make an excuse and leave; her perfume is unbearable. ",	// c+
"i tell her i can't wait any longer, that we're through. ",	// d-
"i tell her i'm not ready for anything physical. ",	// d+
////FAILY
"she yells me that i don't listen to her, and to leave. ",	// a-
"she says i'm too quiet for her, not her type. ",	// a+
"she says she's not physically attracted to me. ",	// b-
"she says that i'll never stay with a girl as ugly as her. ",	// b+
"she says I need to take a shower.  i leave, embarrassed.  ",	// c-
"",	// c+
"she tells me that I'm not sexual enough for her. ",	// d-
"she tells me to take my hands off, to leave. ",	// d+
////FAILBOTH
"we spend the evening talking over one-another. ",	// a-
"we sit in silence together the whole evening. ",	// a+
"we were both too shy, in the end, to even establish eye-contact. ",	// b-
"we sit, gazing into each-other's eyes, for hours. ",	// b+
"we never really connected, that night. ",	// c-
"we finally embrace; she smells so perfect. ",	// c+
"we talk well into the night, without touching once. ",	// d-
"i awake the next morning, in her arms. ",	// d+
},
};
